#include"Image.h"

#include<stdio.h>
#include<algorithm>
#include<string>
#include<vector>
#include<math.h>
#include<assert.h>
#include<random>

using namespace std;
using lf = double;

using namespace IMAGE;

struct vec2 {
	lf x, y;
	vec2() {
		x = y = 0;
	}
	vec2(lf x, lf y) :x(x), y(y) {}

	vec2 operator +(const vec2& z) {
		return vec2(x + z.x, y + z.y);
	}
	vec2 operator -(const vec2& z) {
		return vec2(x - z.x, y - z.y);
	}
	vec2 operator *(const lf& z) {
		return vec2(x * z, y * z);
	}
	lf operator *(const vec2& z) {
		return x * z.x + y * z.y;
	}
	lf operator %(const vec2& z) {
		return x * z.y - y * z.x;
	}
	void normalize() {
		lf dd = sqrt(x * x + y * y);
		x /= dd;
		y /= dd;
	}
};
Image img;
Image imageaa;
int width = 480;
int height = 480;
lf padding = 8;
lf border_scale = 0.01;

mt19937 rnd;
int nextint(int s, int t) {
	return (int)(rnd() % (t - s + 1)) + s;
}

void inil()
{
	int i, j, k;
	img.setsize(width, height);

	imageaa.Load("numbers/aa.png");
	{
		for (int j = 0; j < imageaa.h; j++) {
			for (int k = 0; k < imageaa.w; k++) {
				int id = (j * imageaa.w + k);
				int z = imageaa.data[id * 4 + 0];
				imageaa.data[id * 4 + 0] = 0;
				imageaa.data[id * 4 + 1] = 0;
				imageaa.data[id * 4 + 2] = 0;
				imageaa.data[id * 4 + 3] = 255 - z;
			}
		}
	}
}
int a[9][9];
int n, m;
void build_data() {
	const char aa[9][9] = {
		"bbccaacc",
		"baacabbc",
		"ccabcbaa",
		"cabbccab",
		"aaccaabb",
		"bbcbbacc",
		"bcabc@bc",
		"ccaaccbb",
	};
	int i, j, k;
	n = m = 8;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			if (aa[i][j] == '@') {
				a[i][j] = 3;
			}
			else {
				a[i][j] = aa[i][j] - 'a';
			}
		}
	}
}
uint8_t color[4][3] = {
	{0, 146, 146},
	{255, 109, 182},
	{255,182,119},
	{20, 20, 20},
};
void fill_in() {
	int i, j, k;
	lf dx = (width - padding * 2.0) / m;
	lf dy = (height - padding * 2.0) / n;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + j * dx;
			lf cy = padding + i * dy;
			k = a[i][j];
			if (k != 3)continue;
			img.draw_rectangle(cx, cy, cx + dx, cy + dy, color[k][0] / 255.0, color[k][1] / 255.0, color[k][2] / 255.0);
			if (k == 3) {
				/*
				int tn = 255;
				for (int l = tn - 1; l >= 0; l--) {
					img.draw_circle(cx + dx * 0.5, cy + dy * 0.5, dx * (l + 1) / tn * 1.5, 0.0, 0.0, 0.0, 1.0 / tn);
				}
				*/
				Image blackhole(imageaa);
				int tn = blackhole.h;
				int tm = blackhole.w;
				for (int ti = 0; ti < tn; ti++) {
					for (int tj = 0; tj < tm; tj++) {
						int id = ti * tm + tj;
						//blackhole.data[id * 4 + 3] = z;
						lf zx = (ti - (lf)(tn - 1) / 2.0) / ((lf)(tn - 1) / 2.0);
						lf zy = (tj - (lf)(tm - 1) / 2.0) / ((lf)(tm - 1) / 2.0);
						lf zz = sqrt(1.0 - min(zx * zx + zy * zy, 1.0));
						int z = zz * 255;
						if (z < 0)z = 0; if (z > 255)z = 255;
						for (int tk = 0; tk < 4; tk++) {
							blackhole.data[id * 4 + tk] = 255;
						}
						blackhole.data[id * 4 + 3] = z;
					}
				}
				img.draw_image(cx - dx * 0.1, cy - dy * 0.1, cx + dx * 1.1, cy + dy * 1.1, blackhole);
				img.draw_image(cx, cy, cx + dx, cy + dy, imageaa);
				//img.draw_image(cx, cy, cx + dx, cy + dy, blackhole);
			}
		}
	}
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + j * dx;
			lf cy = padding + i * dy;
			k = a[i][j];
			if (k == 3)continue;
			img.draw_rectangle(cx, cy, cx + dx, cy + dy, color[k][0] / 255.0, color[k][1] / 255.0, color[k][2] / 255.0);
		}
	}
}
void draw_inner_border() {
	int i, j, k;
	int ddx[4] = { 0,1,0,-1 };
	int ddy[4] = { 1,0,-1,0 };
	int ddxz[4] = { 1, 1, 0, 0 };
	int ddxw[4] = { 1, 0, 0, 1 };
	int ddyz[4] = { 0, 1, 1, 0 };
	int ddyw[4] = { 1, 1, 0, 0 };
	lf dx = (width - padding * 2.0) / m;
	lf dy = (height - padding * 2.0) / n;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			{
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					if (ti >= 0 && ti < n && tj >= 0 && tj < m && a[ti][tj] == a[i][j])
					{
						lf zwx = dx * (ddxw[k] - ddxz[k]);
						lf zwy = dy * (ddyw[k] - ddyz[k]);
						for (int l = 0; l < 9; l += 2) {
							img.draw_line(cx + dx * ddxz[k] + l * zwx / 9.0, cy + dy * ddyz[k] + l * zwy / 9.0, cx + dx * ddxz[k] + (l + 1) * zwx / 9.0, cy + dy * ddyz[k] + (l + 1) * zwy / 9.0, min(dx, dy) * border_scale, 0.9, 0.9, 0.9);
						}
					}
				}
			}
		}
	}
}
void draw_outter_border() {
	int i, j, k;
	int ddx[4] = { 0,1,0,-1 };
	int ddy[4] = { 1,0,-1,0 };
	int ddxz[4] = { 1, 1, 0, 0 };
	int ddxw[4] = { 1, 0, 0, 1 };
	int ddyz[4] = { 0, 1, 1, 0 };
	int ddyw[4] = { 1, 1, 0, 0 };
	lf dx = (width - padding * 2.0) / m;
	lf dy = (height - padding * 2.0) / n;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			{
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					if (ti >= 0 && ti < n && tj >= 0 && tj < m && a[ti][tj] == a[i][j]) continue;

					img.draw_line(cx + dx * ddxz[k], cy + dy * ddyz[k], cx + dx * ddxw[k], cy + dy * ddyw[k], min(dx, dy) * border_scale, 0.1, 0.1, 0.1);
				}
			}
		}
	}
}
int main() {
	int i, j, k;
	inil();
	build_data();
	img.mSamplingMode = SamplingModeType::SAMPLING_3x3;
	fill_in();
	draw_inner_border();
	draw_outter_border();
	img.Save("tromino_ex2.png");
}